#include <inavr.h>
#include "defines.h"
#include "serial.h"
#include "flash.h"
#include "stdint.h"

#define TWI_DDR_REG			DDRD
#define TWI_PORT_REG		PORTD
#define TWI_SCL_PIN			PD0
#define TWI_SDA_PIN			PD1

#define BOOT_DDR_REG		DDRC
#define BOOT_PORT_REG		PORTC
#define BOOT_PIN			PC0

#define RESET_DDR_REG		DDRC
#define RESET_PORT_REG		PORTC
#define RESET_PIN			PC1

// ]uɊÂʐM̌`I
#if defined(_ATTINY25)   || defined(_ATTINY25V) || \
	defined(_ATTINY45)   || defined(_ATTINY45V) || \
	defined(_ATTINY85)   || defined(_ATTINY85V) || \
	defined(_ATTINY24)   || defined(_ATTINY24A) || \
	defined(_ATTINY44)   || defined(_ATTINY44A) || \
	defined(_ATTINY84)   || defined(_ATTINY84A) || \
	defined(_ATTINY2313) || defined(_ATTINY2313A) || \
	defined(_ATTINY4313) || defined(_ATTINY4313A) || \
	defined(_ATTINY261)  || defined(_ATTINY261A) || \
	defined(_ATTINY461)  || defined(_ATTINY461A) || \
	defined(_ATTINY861)  || defined(_ATTINY861A) || \
	defined(_ATTINY43U)  || \
	defined(_ATTINY87)   || \
	defined(_ATTINY167)
#define _USI								// ʐM`USIƂĐݒ

#endif
#if defined(_ATTINY48) || defined(_ATTINY88) || \
	defined(_ATMEGA48A) || defined(_ATTINY48PA)
#define _TWI

#endif

// 2K޲ ׯº۰חp߰ޗeʑI
#if defined(_ATTINY25)   || defined(_ATTINY25V) || \
	defined(_ATTINY24)   || defined(_ATTINY24A) || \
	defined(_ATTINY2313) || defined(_ATTINY2313A) || \
	defined(_ATTINY261)  || defined(_ATTINY261A)

	#define PAGE_SIZE		32				// 16=32޲
	#define MAX__APP_ADDR	0X0400			// ő剞pڽ
#endif
// 4K޲ ׯº۰חp߰ޗeʑI
#if defined(_ATTINY45)   || defined(_ATTINY45V) || \
	defined(_ATTINY44)   || defined(_ATTINY44A) || \
	defined(_ATTINY4313) || defined(_ATTINY4313A) || \
	defined(_ATTINY461)  || defined(_ATTINY461A) || \
	defined(_ATTINY43U)  || \
	defined(_ATTINY48)   || \
	defined(_ATMEGA48)   || defined(_ATMEGA48A)  || \
	defined(_ATMEGA48PA)

	#define PAGE_SIZE		64				// 32=64޲
	#define MAX__APP_ADDR	0X0C00			// ő剞pڽ
#endif
// 8K޲ ׯº۰חp߰ޗeʑI
#if defined(_ATTINY85)   || defined(_ATTINY85V) || \
	defined(_ATTINY84)   || defined(_ATTINY84A) || \
	defined(_ATTINY861)  || defined(_ATTINY861A) || \
	defined(_ATTINY87)   || \
	defined(_ATTINY88)

	#define PAGE_SIZE		64				// 32=64޲
	#define MAX__APP_ADDR	0X1800			// ő剞pڽ
											// 0x1c001K޲Ăް۰ނӖ܂B
											// 0x18002K޲Ăް۰ނӖ܂B
#endif
// 16K޲ ׯº۰חp߰ޗeʑI
#if defined(_ATTINY167) 

	#define PAGE_SIZE		128				// 64=128޲
	#define MAX__APP_ADDR	0X3C00			// ő剞pڽ
#endif

#define SLAVE_ADDRESS 0xb0

#define _BV( __THE_LOCATION_OF_PIN__ )    ( 1u << __THE_LOCATION_OF_PIN__ )

unsigned char BlockLoad(unsigned int size, unsigned char mem);
/* e(BLOCKSIZE)͈ȉ̗e(BLOCKSIZE*n=PAGESIZEAn=1,2,3,`)̂悤ɑI΂ׂłB*/

#define BLOCKSIZE PAGE_SIZE

void InitTWI( void )
{
	TWI_DDR_REG &= ~((1 << TWI_SCL_PIN) | (1 << TWI_SDA_PIN));
	TWI_PORT_REG &= ~((1 << TWI_SCL_PIN) | (1 << TWI_SDA_PIN));

	// TWI呕uƂď
	TWCR = (1 << TWEN);
	TWBR = 16;								// 8MHz250bps
}

#define TWI_CMD_PAGEUPDATE		0x01
#define TWI_CMD_EXECUTEAPP		0x02
#define TWI_CMD_AVERSION		0x03
#define TWI_CMD_BVERSION		0x04
#define TWI_CMD_ERASEFLASH		0x05
#define TWI_CMD_CRCCHECK		0x06
#define TWI_CMD_GETERRCONDN		0x07

#define TWI_START_TRANSMITTED	0x08
#define TWI_SLAW_ACKED			0x18
#define TWI_TXDATA_ACKED		0x28
#define TWI_TXDATA_NACKED		0x30
#define TWI_SLAR_ACKED			0x40
#define TWI_RXDATA_ACKED		0x50
#define TWI_RXDATA_NACKED		0x58

uint8_t statusCode;
uint8_t success;
uint8_t over_size_flag=0;

void cycle_reset(void)
{
	RESET_PORT_REG &= ~(1 << RESET_PIN);
	__delay_cycles( 10000 );
	RESET_PORT_REG |= (1 << RESET_PIN);
	__delay_cycles( 10000 );
}

uint8_t MasterReceive( uint8_t address, uint8_t * data, uint16_t length )
{
	uint8_t error = 0;

	// Jn
	TWCR = (1 << TWINT) | (1 << TWSTA) | (1 << TWEN);
	do {} while ((TWCR & (1 << TWINT)) == 0);
	error = (TWSR != TWI_START_TRANSMITTED);

	// SLA+Ro
	if (!error) {
		TWDR = (address & ~0x01) | 0x01;	// LSBݒ=ǂݍ
		TWCR = (1 << TWINT) | (1 << TWEN);
		do {} while ((TWCR & (1 << TWINT)) == 0);
		error = (TWSR != TWI_SLAR_ACKED);
	}

	// ް ޲-Ō1ǂݍ݁AACKԂB
	uint8_t * bufferPtr = data;
	if (!error) {
		for (uint16_t i = 0; i < (length - 1); ++i) {
			TWCR = (1 << TWINT) | (1 << TWEA) | (1 << TWEN);
			do {} while ((TWCR & (1 << TWINT)) == 0);
			error = (TWSR != TWI_RXDATA_ACKED);
			if (!error) {
				*bufferPtr = TWDR;
				++bufferPtr;
			} else {
				break;
			}
		}
	}

	// Ōް ޲ēǂݍ݁ANACKԂB
	if (!error) {
		TWCR = (1 << TWINT) | (1 << TWEN);
		do {} while ((TWCR & (1 << TWINT)) == 0);
		error = (TWSR != TWI_RXDATA_NACKED);
		if (!error) {
			*bufferPtr = TWDR;
			TWCR = (1 << TWSTO) | (1 << TWINT) | (1 << TWEN);
		}
	}

	// ُȂΒʐM~
	if (error) {
		TWCR = (1 << TWSTO) | (1 << TWINT) | (1 << TWEN);
	}

	return (!error);
}

void get_slave_status(void)
{
	do {
		success = MasterReceive( SLAVE_ADDRESS, &statusCode, 1 );
	} while ((statusCode != 0) || (!success));
}

uint8_t MasterTransmit( uint8_t address, uint8_t * data, uint16_t length )
{
	uint8_t error = 0;

	// Jn
	TWCR = (1 << TWINT) | (1 << TWSTA) | (1 << TWEN);
	do {} while ((TWCR & (1 << TWINT)) == 0);
	error = (TWSR != TWI_START_TRANSMITTED);

	// SLA+Wo
	if (!error) {
		TWDR = (address & ~0x01) | 0x00;	// LSB=
		TWCR = (1 << TWINT) | (1 << TWEN);
		do {} while ((TWCR & (1 << TWINT)) == 0);
		error = (TWSR != TWI_SLAW_ACKED);
	}

	// ް ޲-Ō1oAACK\z
	const uint8_t * bufferPtr = data;
	if (!error) {
		for (uint16_t i = 0; i < (length - 1); ++i) {
			TWDR = *bufferPtr;
			TWCR = (1 << TWINT) | (1 << TWEN);
			do {} while ((TWCR & (1 << TWINT)) == 0);
			error = (TWSR != TWI_TXDATA_ACKED);
			if (!error) {
				++bufferPtr;
			} else {
				break;
			}
		}
	}

	// Ōް ޲đoANACK\z
	if (!error) {
		TWDR = *bufferPtr;
		TWCR = (1 << TWINT) | (1 << TWEN);
		do {} while ((TWCR & (1 << TWINT)) == 0);
		error = (TWSR != TWI_TXDATA_NACKED);
		if (!error) {
			TWCR = (1 << TWSTO) | (1 << TWINT) | (1 << TWEN);
		}
	}

	// ُȂΒʐM~
	if (error) {
		TWCR = (1 << TWSTO) | (1 << TWINT) | (1 << TWEN);
	}

	return (!error);
}

uint8_t pageBuffer[PAGE_SIZE+3];
uint16_t addr=0;

void First_Time(void)
{
	addr=0;
	InitTWI();
	pageBuffer[0] = TWI_CMD_PAGEUPDATE;
	BOOT_PORT_REG &= ~( 1 << BOOT_PIN );
	cycle_reset();
	get_slave_status();
}

uint8_t command_char=0, data_char=0, CRC_HI=0, CRC_LO=0;
uint8_t runApp[2];
uint8_t reps=0;

void read_from_slave(void)
{
	if (success)
	{
		do {
			success = MasterReceive( SLAVE_ADDRESS, &statusCode, 1 );
		} while ( !success );
	}
}

void read_and_send(uint8_t whichversion)
{
	runApp[0]=whichversion;
	runApp[1]=whichversion;
	BOOT_PORT_REG &= ~( 1 << BOOT_PIN );
	cycle_reset();
	get_slave_status();
	success = MasterTransmit( SLAVE_ADDRESS, runApp, 2 );
	read_from_slave();
	sendchar( statusCode );
}

void send_command(uint8_t command)
{
	runApp[0] = command;
	runApp[1] = command;
	BOOT_PORT_REG &= ~( 1 << BOOT_PIN );
	cycle_reset();
	get_slave_status();
	success = MasterTransmit( SLAVE_ADDRESS, runApp, 2 );
}

/*************************************************************************/
__C_task void main(void)
{
	unsigned int temp_int;
	unsigned char val=0;

	InitTWI();


	BOOT_DDR_REG |= (1 << BOOT_PIN);
	BOOT_PORT_REG &= ~(1 << BOOT_PIN);

	RESET_DDR_REG |= (1 << RESET_PIN);
	RESET_PORT_REG |= (1 << RESET_PIN);

	initbootuart();							// UART
	/* JԂ */
	for(;;)
	{
		val=recchar();						// ߕMҋ@

		// ۸ݸޓڍs/o
		if(( val ==  'P') || ( val == 'L'))
		{
			sendchar('\r');					// ʂȏȂAm艞
		}

		// ް ۰ޒEo
		else if(val == 'E')
		{
			sendchar('\r');					// ʂȏȂAm艞
		}

		// {޲ēǂݍ݁ˎs
		else if( val == 'r')
		{
			if( command_char == 'a')
			{
				BOOT_PORT_REG &= ~( 1 << BOOT_PIN );
				read_and_send( TWI_CMD_AVERSION );
			}
			else if( command_char == 'b' )
			{
				BOOT_PORT_REG &= ~( 1 << BOOT_PIN );
				read_and_send( TWI_CMD_BVERSION );
			}                             
			else if( command_char == 'd' )
			{
				// CRCHIǂݍ
				sendchar(CRC_HI);
			}
			else if( command_char == 'e' )
			{
				// CRCLOǂݍ
				sendchar(CRC_LO);
			}
			else if( command_char == 'f' )
			{
				BOOT_PORT_REG &= ~( 1 << BOOT_PIN );
				// ԏ
				read_and_send(TWI_CMD_GETERRCONDN);
			}
			else
				sendchar(0xFF);

		}
		// {޲ď݁ːݒ薽
		else if( val == 'l')
		{
			command_char = recchar();
			if( command_char == 'c' )
			{
				BOOT_PORT_REG &= ~( 1 << BOOT_PIN );
				send_command( TWI_CMD_CRCCHECK );
				read_from_slave();
				CRC_HI= statusCode;
				read_from_slave();
				CRC_LO = statusCode;
			}
			sendchar('\r');
		}

		// ˭ޏޯēǂݍ݁BVERSION 
		else if( val == 'N' )
		{
			BOOT_PORT_REG &= ~( 1 << BOOT_PIN );
			read_and_send( TWI_CMD_BVERSION );
		}

		// ˭މޯēǂݍ݁AVERSION
		else if( val == 'F' )
		{
			BOOT_PORT_REG &= ~( 1 << BOOT_PIN );
			read_and_send( TWI_CMD_AVERSION );
		}

		else  if(val == 'a' )				// ڽis
		{
			sendchar('Y');					// is
		}

		else if(val=='A')					// ڽw薽
		{	// :ׯ ڽ޲Ăł͂Ȃŗ^܂B
			addr =(recchar()<<8) | recchar();	// ڽ/޲ĎM
			addr = addr<<1;
			if(addr > MAX__APP_ADDR) over_size_flag =1;
			pageBuffer[1] = (uint8_t)(addr&0x00FF);
			addr = addr>>8;
			pageBuffer[2] = (uint8_t)(addr&0x00FF);
			sendchar('\r');					// m艞
		}

		// ߏ
		else if(val == 'e' )
		{
			runApp[0] =  TWI_CMD_ERASEFLASH;
			runApp[1] =  TWI_CMD_ERASEFLASH;
			BOOT_PORT_REG &= ~( 1 << BOOT_PIN );
			cycle_reset();
			get_slave_status();
			success = MasterTransmit( SLAVE_ADDRESS, runApp, 2 );
			sendchar('\r');					// m艞
		}

		// (Ä)ǂݏx
		else if(val == 'b' )
		{
			sendchar('Y');					// ǂݏx
			sendchar((BLOCKSIZE>>8) & 0xFF);	// (޲)eʏ޲Ă
			sendchar(BLOCKSIZE&0xFF);			// (޲)eʉ޲Ă
		}

		// (Ä)ݖ
		else  if(val == 'B' )
		{
			temp_int = (recchar()<<8) | recchar();	// eʎ擾
			val = recchar();				// ؎ʎ擾
			sendchar( BlockLoad(temp_int,val) );	// 򏑂݊Jn
			if(reps == 0)
				First_Time();
			success = MasterTransmit( SLAVE_ADDRESS, pageBuffer, PAGE_SIZE+3 );
			if (success)
			{
				get_slave_status();
			}
			reps ++;
		}

		// ݊펯ʎqԂB
		else if(val == 'S' )
		{
			sendchar('A');					// 'AVRBOOT'ԂB
			sendchar('V');					// ĳʎq(݊펯[)͏7łB
			sendchar('R');
			sendchar('B');
			sendchar('O');
			sendchar('O');
			sendchar('T');
			reps =0;
		}

		// ĳŔԍԂB
		else if(val == 'V' )
		{
			send_command(TWI_CMD_EXECUTEAPP);
			// ]uɑ΂ް۰ޓ֎~
			BOOT_PORT_REG |= (1 << BOOT_PIN);
			sendchar('2');
			sendchar('0');
		}

		// [޲ĂԂB
		else if(val == 's')
		{
			sendchar( SIGNATURE_BYTE_3 );
			sendchar( SIGNATURE_BYTE_2 );
			sendchar( SIGNATURE_BYTE_1 );
		}

		else if(val != 0x1b)				// ESCłȂ΂͖F
			sendchar('?');

	} // for(;;)I
} // mainI

unsigned char BlockLoad(unsigned int size, unsigned char mem)
{
	// ׯ ،`
	if(!over_size_flag)						// ̧ٗeʂ۸ݸނłő߰ވȉ
	{
		if(mem=='F')
		{
			for (uint16_t i = 0; i < size; ++i)
			{
				pageBuffer[i+3] = recchar();
			}
			return '\r';					// ۸ݸOK
		}

		// ،`?
		else
		{
			return '?';
		}
	}
	else
	{
	over_size_flag=0;
	return '?';
	}
}
