#ifdef __USI__

#include "USI_TWI_Slave.h"
#include "Common_Define.h"

/*****************************************************************************/
// USI_TWIݏ
#define USI_TWI_WRITE_ADDR_HI_BYTE			(0x00)
#define USI_TWI_WRITE_ADDR_LO_BYTE			(0x01)
#define USI_TWI_WRITE_DATA_BYTE				(0x02)

// USI_TWI
#define USI_TWI_OVERFLOW_STATE_NONE			(0x00)
#define USI_TWI_OVERFLOW_STATE_ACK_PR_RX	(0x01)
#define USI_TWI_OVERFLOW_STATE_DATA_RX		(0x02)
#define USI_TWI_OVERFLOW_STATE_ACK_PR_TX	(0x03)
#define USI_TWI_OVERFLOW_STATE_PR_ACK_TX	(0x04)
#define USI_TWI_OVERFLOW_STATE_DATA_TX		(0x05)

// USI_TWIԒl
static uint8_t USI_TWI_SLAVE_Write_State;
static uint8_t USI_TWI_SLAVE_Overflow_State;
static uint8_t Command_Flag;

// TWI׸ޒl
static uint8_t USI_TWI_SLAVE_Address_Update;

// ]ue߰ ڽl
static uint16_t USI_TWI_SLAVE_PAGE_Address;

/******************************************************************************/

/* Ǐϐ */
static uint8_t TWI_RxBuf[TWI_RX_BUFFER_SIZE];
static volatile uint8_t TWI_RxHead;
static volatile uint8_t TWI_RxTail;

static uint8_t TWI_TxBuf[TWI_TX_BUFFER_SIZE];
static volatile uint8_t TWI_TxHead;
static volatile uint8_t TWI_TxTail;

static unsigned char USI_TWI_SlaveAddress;

//********** USI_TWI֐ **********//
void USI_TWI_SLAVE_Init( uint8_t TWI_OwnAddress )
{

	USI_TWI_SlaveAddress = TWI_OwnAddress;

	DDR_USI  &= ~(1<<PORT_USI_SDA);			// SCL͂ƂĐݒ
	PORT_USI &= ~(1<<PORT_USI_SDA);			// SDA=Highݒ

	DDR_USI  |=  (1<<PORT_USI_SCL);			// SCLo͂ƂĐݒ
	PORT_USI |=  (1<<PORT_USI_SCL);			// SCL=Highݒ

	USICR = (0<<USISIE)|(0<<USIOIE)|		// Jn荞݋Aꊄ荞݋֎~
			(1<<USIWM1)|(0<<USIWM0)|		// USI2ɐݒAŏ̊Jnɐ旧USIvȂ(ݓIȎs)
			(1<<USICS1)|(0<<USICS0)|(0<<USICLK)|	//  ڼ޽ ۯ=OA[
			(0<<USITC);

	// 荞׸މƌvؾ
	USISR = (1<<USISIF) | (1<<USIOIF) | (1<<USIPF) |	// 荞׸މ
			(1<<USIDC) |(0x0<<USICNT0);		// 8ޯĂ܂16ތݐ؂ւ̎USI

	// USI TWIJn荞݋
	USICR |= (1<<USISIE);
}

// ȉ̊֐`ɂĒǉ܂B
/*****************************************************************************/
void USI_TWI_SLAVE_Abort()
{
	USICR = (0<<USISIE)|(0<<USIOIE)|		// Jn荞݋֎~Aꊄ荞݋֎~
			(0<<USIWM1)|(0<<USIWM0)|		// 2USIؾāAŏ̊Jnɐ旧USIvȂ(ݓIȎs)
			(0<<USICS1)|(0<<USICS0)|(0<<USICLK)|	//  ڼ޽ ۯ=A[
			(0<<USITC);

	// TWIʐM̪SCLSDA̐ؾ
	DDR_USI  &= ~(1<<PORT_USI_SDA);
	PORT_USI &=  ~(1<<PORT_USI_SDA);		// SDALowɐݒ

	DDR_USI  |=  ~(1<<PORT_USI_SCL);
	PORT_USI |=  ~(1<<PORT_USI_SCL);		// SCLLowɐݒ

	// USIް ڼ޽
	USIDR = 0x00;

	// 荞׸މƌvؾ
	USISR = (1<<USISIF) | (1<<USIOIF) | (1<<USIPF) |	// 荞׸މ
			(1<<USIDC) |(0x0<<USICNT0);		// 8ޯĂ܂16ތݐ؂ւ̎USI
}

void USI_TWI_SLAVE_ReadAndProcessPacket ()
{

	// USI TWIJn
	if (USISR & (1<<USISIF))
	{
		// USI TWIJn
		USI_TWI_SLAVE_Process_Start_Condition();
	}

	// USI_TWI_SLAVE
	if (USISR & (1<<USIOIF))
	{
		// TWI
		USI_TWI_SLAVE_Process_Overflow_Condition();

/* ̕ɎvĂ邽...
		// TWIڽXVׂ?
		if (USI_TWI_SLAVE_Address_Update)
		{
			// Ƃް۰ނLB
			bootloader_active = 1;

			// ް۰ނ𔲂ȱڽ
			if (USI_TWI_SLAVE_PAGE_Address != 0xffff)
			{
				// TWIڽݒB͓ǂݏ̂߂ׯ̑Ή߰ނ
				// ۸ݸފɏՕɐݒ肵܂B
//				prog_buffer_set_address(USI_TWI_SLAVE_PAGE_Address);
			}

			// ׸ ؾ
			USI_TWI_SLAVE_Address_Update = 0;
		}

.....܂.........*/

	}

	// TWI~
	if (USISR & (1<<USIPF))
	{
		// ~׸މ
		USISR = (1<<USIPF);
		// ް۰ނ𔲂ȱڽ
		if (USI_TWI_SLAVE_PAGE_Address == 0xffff)
		{
			// ް۰ޔo׸ނݒ
			bootloader_exit = 1;
		}
		else
		{
			// KvȂA۸ݸފɏՕXV
//			kk prog_buffer_update();
		}
	}

}


/******************************************************************************/
// :
// USI TWIJnBTWI呕uTWIJn\邱ƂɂUSI
// TWI]uƂ̒ʐMn߂鎞ɌĂ΂܂B
/******************************************************************************/
void USI_TWI_SLAVE_Process_Start_Condition(void)
{
	// SCLLowɂȂ鎞A"Jn"܂ő҂܂BSCLLowɂȂ̂
	// ̂s̏ꍇASCLJڂް ۯ ٽ1ƂĊԈႢ邽߁Aް
	// ɑ΂ۯ ٽԈႦ邩܂B
	while ((PIN_USI & (1<<PORT_USI_SCL)));
	// ؾ
	USI_TWI_SLAVE_Overflow_State = USI_TWI_SLAVE_OVERFLOW_STATE_NONE;
	// 荞׸މƌvؾ
	USISR = (1<<USISIF) | (1<<USIOIF) | (1<<USIPF) |	// 荞׸މ
			(0x00<<USICNT0);							// 8ޯĂ܂16ތݐ؂ւ̎USI

	// 荞݁A`ԁAۯݒXV
	USICR = (1<<USISIE) | (1<<USIOIE) |					// ƊJn̊荞݂
			(1<<USIWM1) | (1<<USIWM0) |					// ۯL2`ԂłUSIێ
			(1<<USICS1) | (0<<USICS0) | (0<<USICLK) |	//  ڼ޽ ۯ=OA[
			(0<<USITC);									// ۯ ݂̌ݐ؂ւȂ
}

/******************************************************************************/

// ߰ޑŜɏ
static uint8_t *bufferPtr = pageBuffer;
static uint8_t Value;

/*******************************************************************************
:
USI_TWI_SLAVEԏ
ް ޲Ă܂ް ޲ĂɌ㑱PACK/NACK޲ĂTWI呕uo͸ۯ
쓮ꂽƂAUSI TWI 4ޯČv킪ꂽɌĂ΂܂B
*******************************************************************************/
void USI_TWI_SLAVE_Process_Overflow_Condition(void)
{
	// USIްɏ
	uint8_t Usi_Data = USIDR;

	// ԂɊÂ荞݂
	switch (USI_TWI_SLAVE_Overflow_State)
	{
		/***********************************************************************/
		// 呕u瑗Mꂽŏ޲(]uڽ)
		case USI_TWI_SLAVE_OVERFLOW_STATE_NONE:
			// ڽM?
			if ((Usi_Data >> 1) == USI_TWI_SlaveAddress)
			{
				// ͂Aް𑗂܂͎󂯂?
				if((Usi_Data & 0x01) == 0x01)
				{
					// USI TWI]uް ޲Ă𑗐MȂ΂Ȃ܂B
					USI_TWI_SLAVE_Overflow_State = USI_TWI_SLAVE_OVERFLOW_STATE_ACK_PR_TX;
				}
				else
				{
					// USI TWI]uް ޲Ă󂯎Ȃ΂Ȃ܂B
					USI_TWI_SLAVE_Overflow_State = USI_TWI_SLAVE_OVERFLOW_STATE_ACK_PR_RX;
				}
				// ݏԂؾ
				// .. Command_flag=1Ŏ̖ߕǉ
//				USI_TWI_SLAVE_Write_State = USI_TWI_SLAVE_WRITE_ADDR_HI_BYTE;

				// SDAo͗pɐݒ
				PORT_USI |= (1<<PORT_USI_SDA);
				DDR_USI |= (1<<PORT_USI_SDA);

				// ްACKɐݒ
				USIDR = 0;

				// ACKpvĐݒ -- 2̸ۯJ
				USISR = 0x0E;
			}
			else
			{
				// BUSIJnoؾāB荞݋A`ԁAۯݒ
				// XVB:̎Ő`Ԃ͌v킪鎞SCLLowɕێ
				// ɐݒ肵Ă͂Ȃ܂BȂ΁ATWI]u͑TWI]u
				// WQł傤B
				USICR = (1<<USISIE) | (0<<USIOIE) |					// Jn荞݋A֎~
						(1<<USIWM1) | (0<<USIWM0) |					// ۯLȂ2`ԂUSIێ
						(1<<USICS1) | (0<<USICS0) | (0<<USICLK) |	//  ڼ޽ ۯ=OA[
						(0<<USITC);									// ۯ ݂̌ݐ؂ւȂ
			}
			break;
		/***********************************************************************/
		// ް󂯎鏀悤Ɏ呕uACKo
		case USI_TWI_SLAVE_OVERFLOW_STATE_ACK_PR_RX:
			if(Command_Flag == 0)
			{
				// ԍXV
				USI_TWI_SLAVE_Overflow_State = USI_TWI_SLAVE_OVERFLOW_STATE_CMD_RX;
			}
			else if(Command_Flag == 1)
			{
				// ԍXV
				USI_TWI_SLAVE_Overflow_State = USI_TWI_SLAVE_OVERFLOW_STATE_DATA_RX;

				// ݏؾ
				USI_TWI_SLAVE_Write_State = USI_TWI_SLAVE_WRITE_ADDR_HI_BYTE;
			}
			else if(Command_Flag == 2)
			{
				// ԍXV
				USI_TWI_SLAVE_Overflow_State = USI_TWI_SLAVE_OVERFLOW_STATE_DATA_TX_AVERSION;
			}
			else if(Command_Flag == 3)
			{
				// ԍXV
				USI_TWI_SLAVE_Overflow_State = USI_TWI_SLAVE_OVERFLOW_STATE_DATA_TX_BVERSION;
			}
			else if(Command_Flag == 4)
			{
				// ԍXV
				USI_TWI_SLAVE_Overflow_State = USI_TWI_SLAVE_OVERFLOW_STATE_DATA_TX_GETERRCONDN;
			}
			// SDA͗pɐݒ
			DDR_USI &= ~(1<<PORT_USI_SDA);
			PORT_USI &= ~(1<<PORT_USI_SDA);
			break;
		/**************************************************************************/
		case USI_TWI_SLAVE_OVERFLOW_STATE_CMD_RX:
			// ԍXV
//			USI_TWI_SLAVE_Overflow_State = USI_TWI_SLAVE_OVERFLOW_STATE_ACK_PR_TX;
			USI_TWI_SLAVE_Overflow_State = USI_TWI_SLAVE_OVERFLOW_STATE_NONE;

//			USI_TWI_SLAVE_Command_Received = Usi_Data;

			// Mߌ`
			if(Usi_Data == TWI_CMD_PAGEUPDATE)
			{
				// ް󂯎邽߂ɂ׸ނݒ
				Command_Flag =1;
			}
			else if(Usi_Data == TWI_CMD_EXECUTEAPP)
			{
				// ۰ׂؾ...

				// ް󂯎邽߂ɂ׸ނݒ
				Command_Flag =0;
			}
			else if(Usi_Data == TWI_CMD_AVERSION)
			{
				// ް󂯎邽߂ɂ׸ނݒ
				Command_Flag =2;
			}
			else if(Usi_Data == TWI_CMD_BVERSION)
			{
				// ް󂯎邽߂ɂ׸ނݒ
				Command_Flag =3;
			}
			else if(Usi_Data == TWI_CMD_ERASEFLASH)
			{
				// ׯ̂ꎩg.......

				// ް󂯎邽߂ɂ׸ނݒ
				Command_Flag =0;
			}
			else if(Usi_Data == TWI_CMD_GETERRCONDN)
			{
				// ް󂯎邽߂ɂ׸ނݒ
				Command_Flag =4;
			}
			else
			{
				// ް󂯎邽߂ɂ׸ނݒ
				Command_Flag =0;

				USI_TWI_SLAVE_Abort();
			}
			break;

		// 呕uްMÂACKo
		case USI_TWI_SLAVE_OVERFLOW_STATE_DATA_RX:
			// ԍXV
			USI_TWI_SLAVE_Overflow_State = USI_TWI_SLAVE_OVERFLOW_STATE_ACK_PR_RX;

			// Command_Flag1Ɋm
			Command_Flag = 1;

			// M޲Ă̌`߂邽߂TWIݏԂ
			if (USI_TWI_SLAVE_Write_State == USI_TWI_SLAVE_WRITE_ADDR_HI_BYTE)
			{
				// TWIڽ޲Ăݒ
				USI_TWI_SLAVE_PAGE_Address = Usi_Data;

				// ̏Ԃݒ
				USI_TWI_SLAVE_Write_State = USI_TWI_SLAVE_WRITE_ADDR_LO_BYTE;
			}
			else if (USI_TWI_SLAVE_Write_State == USI_TWI_SLAVE_WRITE_ADDR_LO_BYTE)
			{
				// ڽ޲Ăݒ
				USI_TWI_SLAVE_PAGE_Address = (USI_TWI_SLAVE_PAGE_Address << 8) | Usi_Data;

				// ۸ݸ ڽݒ
				USI_TWI_SLAVE_Address_Update = 1;

				// ̏Ԃݒ
				USI_TWI_SLAVE_Write_State = USI_TWI_SLAVE_WRITE_DATA_BYTE;
			}
			else
			{
				// ɏՕް
//				USI_TWI_SLAVE_prog_buffer_set_byte(Usi_Data);

				*bufferPtr = Usi_Data;

				// ߰ޓ޲ ڽis()
//				++prog_byte_address;

				++bufferPtr;
				++Value;
				// ۂ߂Ɋւ޲ ڽ // Ō
				if (Value >(PAGE_SIZE - 1))
				{
					UpdatePage (USI_TWI_SLAVE_PAGE_Address);
					Value = 0;
					bufferPtr =0;
				}
			}

			// SDAo͗pɐݒ
			PORT_USI |= (1<<PORT_USI_SDA);
			DDR_USI |= (1<<PORT_USI_SDA);

			// ACKpްݒ
			USIDR = 0;

			// ACKpɌvĐݒ -- 2ۯJ
			USISR = 0x0E;
			break;

		/***********************************************************************/
		case USI_TWI_SLAVE_OVERFLOW_STATE_DATA_TX_AVERSION:
			// ԍXV
			USI_TWI_SLAVE_Overflow_State = USI_TWI_SLAVE_OVERFLOW_STATE_PR_ACK_TX;

			// SDA͗pɐݒ
			DDR_USI &= ~(1<<PORT_USI_SDA);
			PORT_USI &= ~(1<<PORT_USI_SDA);

			// ACKpɌvĐݒ -- 2ۯJ
			USISR = 0x0E;
			break;

		/***********************************************************************/
		case USI_TWI_SLAVE_OVERFLOW_STATE_DATA_TX_BVERSION:
			break;

		/***********************************************************************/ 
		case USI_TWI_SLAVE_OVERFLOW_STATE_DATA_TX_GETERRCONDN:
		break;

		/***********************************************************************/
		// 呕uACKMANACKMȂUSIؾ
		case USI_TWI_SLAVE_OVERFLOW_STATE_PR_ACK_TX:
			// NACKɊւčŉޯČ? ݒȂA呕u͂ȏް߂Ă܂B
			if (Usi_Data & 0x01)
			{
				// ԍXV
				USI_TWI_SLAVE_Overflow_State = USI_TWI_SLAVE_OVERFLOW_STATE_NONE;

				// JnoUSIؾāB荞݋A`ԁAۯݒ
				// XVB:̎ԂŐ`Ԃ͌v킪鎞SCLLow
				// ێ悤ɐݒ肵Ă͂Ȃ܂BȂ΁ATWI]
				// u͑TWI]uWQł傤B
				USICR = (1<<USISIE) | (0<<USIOIE) |					// Jn荞݋A֎~
						(1<<USIWM1) | (0<<USIWM0) |					// ۯLȂ2`ԂUSIێ
						(1<<USICS1) | (0<<USICS0) | (0<<USICLK) |	//  ڼ޽ ۯ=OA[
						(0<<USITC);									// ۯ ݂̌ݐ؂ւȂ

				// ꊄ荞׸މASCLł̕ێJ
				USISR |= (1<<USIOIF);

				return;
			}

		/***********************************************************************/
		// ް޲đo
		case USI_TWI_SLAVE_OVERFLOW_STATE_ACK_PR_TX:
			// ԍXV
//			USI_TWI_SLAVE_Overflow_State = USI_TWI_SLAVE_OVERFLOW_STATE_DATA_TX;
			USI_TWI_SLAVE_Overflow_State = USI_TWI_SLAVE_OVERFLOW_STATE_DATA_TX_AVERSION;

			// SDAo͗pɐݒ
			PORT_USI |= (1<<PORT_USI_SDA);
			DDR_USI |= (1<<PORT_USI_SDA);

			// ް擾
//			USIDR = prog_buffer_get_byte();
			USIDR = 0X33;
			break;

		/***********************************************************************/
		// ް呕u֑oÂACKM̏
		case USI_TWI_SLAVE_OVERFLOW_STATE_DATA_TX:
			// ԍXV
			USI_TWI_SLAVE_Overflow_State = USI_TWI_SLAVE_OVERFLOW_STATE_PR_ACK_TX;

			// SDA͗pɐݒ
			DDR_USI &= ~(1<<PORT_USI_SDA);
			PORT_USI &= ~(1<<PORT_USI_SDA);

			// ACKpɌvĐݒ -- 2ۯJ
			USISR = 0x0E;
			break;

		/***********************************************************************/
	}
	// ꊄ荞׸މASCLł̕ێJ
	USISR |= (1<<USIOIF);
}

/******************************************************************************/
/*
void prog_buffer_set_byte(uint8_t databyte)
// ݂̱ڽ޲Ăݒ
{
	uint8_t *bufferPtr = pageBuffer;

	// ㏑邱Ƃؾ ޸邱Ƃɂް۰ނیBؾ
	// ޸͐擪߰ނ̍ŏ2޲ĂłB
	if ((prog_page_address != 0) || ((*bufferPtr != 0) && (*bufferPtr != 1)))
	{
		// ۸ݸފɏՕ޲Ăݒ
//		prog_buffer[prog_byte_address] = databyte;
		*bufferPtr = databyte;
	}

	// ߰ޓ޲ ڽis()
//	++prog_byte_address;
	++bufferPtr;

	// ۂ߂Ɋւ޲ ڽ
	if (*bufferPtr >(PAGE_SIZE - 1)) 
		*bufferPtr = 0;

	// ۸ݸލXV׸ސݒA۸ݸފɏՕׯ֏ׂƂ܂B
	prog_update_flag = 1;
}
*/

#endif
